/**********************************************************************/
/*                                                                    */
/*  ARSDDEEX.H                                                        */
/*                                                                    */
/*  DESCRIPTION:  Header file containing external declarations for    */
/*                the OnDemand DDE interface.                         */
/*                                                                    */
/* COPYRIGHT:                                                         */
/*  5622-662 (C) COPYRIGHT IBM CORPORATION 1996,1997                  */
/*  All Rights Reserved                                               */
/*  Licensed Materials - Property of IBM                              */
/*                                                                    */
/*  US Government Users Restricted Rights - Use, duplication or       */
/*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp. */
/*                                                                    */
/* NOTE: This program sample is provided on an as-is basis.           */
/*       The licensee of the OnDemand product is free to copy, revise,*/
/*       modify, and make derivative works of this program sample     */
/*       as they see fit.                                             */
/*                                                                    */
/**********************************************************************/
#ifndef _H_DDEEX_
#define _H_DDEEX_

/**********************************************************************/
/* DDE Service and Topic Names                                        */
/**********************************************************************/
#define ARS_DDE_SERVICE                       "ARS"
#define ARS_DDE_TOPIC                         "ARS"

/**********************************************************************/
/* DDE Commands                                                       */
/**********************************************************************/
#define ARS_DDE_CMD_ACTIVATE_DOC              "ACTIVATE_DOC"
#define ARS_DDE_CMD_ACTIVATE_FOLDER           "ACTIVATE_FOLDER" 
#define ARS_DDE_CMD_ANNOTATE_DOC              "ANNOTATE_DOC"
#define ARS_DDE_CMD_ARRANGE_DOC_WINDOWS       "ARRANGE_DOCS"
#define ARS_DDE_CMD_CLEAR_ALL_FIELDS          "CLEAR_FIELDS"
#define ARS_DDE_CMD_CLOSE_ALL_DOCS            "CLOSE_ALL_DOCS"
#define ARS_DDE_CMD_CLOSE_ALL_FOLDERS         "CLOSE_ALL_FOLDERS"
#define ARS_DDE_CMD_CLOSE_DOC                 "CLOSE_DOC"
#define ARS_DDE_CMD_CLOSE_FOLDER              "CLOSE_FOLDER"
#define ARS_DDE_CMD_COPY_DOC_PAGES            "COPY_DOC_PAGES"
#define ARS_DDE_CMD_DELETE_DOC                "DELETE_DOC"
#define ARS_DDE_CMD_UPDATE_DOC                "UPDATE_DOC"
#define ARS_DDE_CMD_DESELECT_DOC              "DESELECT_DOC"
#define ARS_DDE_CMD_DISABLE_SWITCH_FOCUS      "DISABLE_SWITCH"
#define ARS_DDE_CMD_ENABLE_SWITCH_FOCUS       "ENABLE_SWITCH"
#define ARS_DDE_CMD_EXIT                      "EXIT"
#define ARS_DDE_CMD_GET_DISPLAY_FIELDS        "GET_DISPLAY_FIELDS"
#define ARS_DDE_CMD_GET_DOC_VALUES            "GET_DOC_VALUES"
#define ARS_DDE_CMD_GET_FOLDER_FIELDS         "GET_FOLDER_FIELDS"
#define ARS_DDE_CMD_GET_FOLDERS               "GET_FOLDERS"
#define ARS_DDE_CMD_GET_NUM_DOC_PAGES         "GET_NUM_DOC_PAGES"
#define ARS_DDE_CMD_GET_NUM_DOCS_IN_LIST      "GET_NUM_DOCS_IN_LIST"
#define ARS_DDE_CMD_GET_PRINTERS              "GET_PRINTERS"
#define ARS_DDE_CMD_GET_QUERY_FIELDS          "GET_QUERY_FIELDS"
#define ARS_DDE_CMD_GET_SERVERS               "GET_SERVERS"
#define ARS_DDE_CMD_LOGOFF                    "LOGOFF"
#define ARS_DDE_CMD_LOGON                     "LOGON"
#define ARS_DDE_CMD_OPEN_DOC                  "OPEN_DOC"
#define ARS_DDE_CMD_OPEN_FOLDER               "OPEN_FOLDER"
#define ARS_DDE_CMD_PRINT_DOC                 "PRINT_DOC"
#define ARS_DDE_CMD_RESTORE_DEFAULTS          "RESTORE_DEFAULTS"
#define ARS_DDE_CMD_RETRIEVE_DOC              "RETRIEVE_DOC"
#define ARS_DDE_CMD_SEARCH_FOLDER             "SEARCH_FOLDER"
#define ARS_DDE_CMD_SELECT_DOC                "SELECT_DOC"
#define ARS_DDE_CMD_SET_FIELD_DATA            "SET_FIELD_DATA"
#define ARS_DDE_CMD_SET_FOCUS                 "SET_FOCUS"
#define ARS_DDE_CMD_SET_HELP_PATH             "SET_HELP_PATH"
#define ARS_DDE_CMD_SET_USER_MSG_MODE         "SET_USER_MSG_MODE"
#define ARS_DDE_CMD_SHOW_WINDOW               "SHOW_WINDOW"
#define ARS_DDE_CMD_STORE_DOC                 "STORE_DOC"
#define ARS_DDE_CMD_CHANGE_PASSWORD           "CHANGE_PASSWORD"

/**********************************************************************/
/* DDE Command Parameters                                             */
/**********************************************************************/
#define ARS_DDE_WINDOW                         'W'
#define ARS_DDE_FOLDER                         'F'

#define ARS_DDE_SWITCH_NUMBER                  'N'
#define ARS_DDE_SWITCH_HANDLE                  'H'
#define ARS_DDE_SWITCH_CLIENT_NAME             'C'

#define ARS_DDE_LOGON_SERVER                   'S'
#define ARS_DDE_LOGON_USERID                   'U'
#define ARS_DDE_LOGON_PASSWORD                 'P'
#define ARS_DDE_LOGON_RETURN_CODE              'R'

#define ARS_DDE_CHANGE_PASSWORD_CUR_PW         'C'
#define ARS_DDE_CHANGE_PASSWORD_NEW_PW1        'N'
#define ARS_DDE_CHANGE_PASSWORD_NEW_PW2        'V'

#define ARS_DDE_CRITERIA_BUTTON_1              '0'
#define ARS_DDE_CRITERIA_BUTTON_2              '1'
#define ARS_DDE_CRITERIA_BUTTON_3              '2'
#define ARS_DDE_CRITERIA_BUTTON_4              '3'
#define ARS_DDE_CRITERIA_BUTTON_5              '4'
#define ARS_DDE_DOCLIST_BUTTON_1               '5'
#define ARS_DDE_DOCLIST_BUTTON_2               '6'
#define ARS_DDE_DOCLIST_BUTTON_3               '7'
#define ARS_DDE_DOCLIST_BUTTON_4               '8'
#define ARS_DDE_DOCLIST_BUTTON_5               '9'
#define ARS_DDE_SUPPRESS_BUTTON_SEARCH         'S'
#define ARS_DDE_SUPPRESS_BUTTON_CLEAR          'C'
#define ARS_DDE_SUPPRESS_BUTTON_RESTORE        'R'
#define ARS_DDE_SUPPRESS_BUTTON_AND_OR         'D'
#define ARS_DDE_SUPPRESS_BUTTON_VIEW           'V'
#define ARS_DDE_SUPPRESS_BUTTON_PRINT          'P'
#define ARS_DDE_SUPPRESS_BUTTON_SORT           'T'
#define ARS_DDE_SUPPRESS_BUTTON_AUDIT          'A'
#define ARS_DDE_SUPPRESS_BUTTON_APPEND         'N'
#define ARS_DDE_SUPPRESS_BUTTON_AUTOSCROLL     'L'

#define ARS_DDE_FIELD_NAME                     'F'
#define ARS_DDE_FIELD_OPERATOR                 'O'
#define ARS_DDE_FIELD_VALUE_1                  '1'
#define ARS_DDE_FIELD_VALUE_2                  '2'
#define ARS_DDE_FIELD_VALUE                    'V'

#define ARS_DDE_SEARCH_APPEND                  'A'
#define ARS_DDE_SEARCH_OR                      'O'

#define ARS_DDE_DOC_ID                         'D'
#define ARS_DDE_DOC_NUMBER                     'N'
#define ARS_DDE_DOC_PATH                       'P'
#define ARS_DDE_DOC_SELECTED                   'S'

#define ARS_DDE_RETRIEVE_RESGRP                'R'
#define ARS_DDE_RETRIEVE_COMBINED              'C'
#define ARS_DDE_RETRIEVE_APPEND                'A'

#define ARS_DDE_STORE_GROUP_NAME               'G'
#define ARS_DDE_STORE_APPL_NAME                'A'

#define ARS_DDE_ARRANGE_CASCADE                'C'
#define ARS_DDE_ARRANGE_TILE_HORZ              'H'
#define ARS_DDE_ARRANGE_TILE_VERT              'V'
#define ARS_DDE_ARRANGE_MAXIMIZE               'Z'
#define ARS_DDE_ARRANGE_RESTORE                'R'

#define ARS_DDE_PRINT_LOCAL                    'L'
#define ARS_DDE_PRINT_SERVER                   'S'
#define ARS_DDE_PRINT_COPIES                   'C'
#define ARS_DDE_PRINT_ROTATE                   'R'
#define ARS_DDE_PRINT_ROTATE_BEST              'B'
#define ARS_DDE_PRINT_ROTATE_ASIS              'A'
#define ARS_DDE_PRINT_ROTATE_PORTRAIT          'P'
#define ARS_DDE_PRINT_ROTATE_LANDSCAPE         'L'
#define ARS_DDE_PRINT_SHRINK                   'K'
#define ARS_DDE_PRINT_MILLIMETERS              'M'

#define ARS_DDE_ANNOTATE_PUBLIC                'U'
#define ARS_DDE_ANNOTATE_OK_TO_COPY            'C'
#define ARS_DDE_PAGE_NUMBER                    'G'

#define ARS_DDE_COPY_DOC_PAGES_ASIS            'A'
#define ARS_DDE_COPY_DOC_PAGES_CURRENT         'C'

#define ARS_DDE_USER_MSG_MODE                  'M'
#define ARS_DDE_USER_MSG_MODE_SHOW             '1'
#define ARS_DDE_USER_MSG_MODE_SHOW_IF_VISIBLE  '2'
#define ARS_DDE_USER_MSG_MODE_SUPPRESS         '3'

/**********************************************************************/
/* DDE Command Parameter Keywords                                     */
/**********************************************************************/
#define ARS_DDE_OPR_EQUAL                     "EQ"
#define ARS_DDE_OPR_NOT_EQUAL                 "NE"
#define ARS_DDE_OPR_LESS_THAN                 "LT"
#define ARS_DDE_OPR_LESS_THAN_OR_EQUAL        "LE"
#define ARS_DDE_OPR_GREATER_THAN              "GT"
#define ARS_DDE_OPR_GREATER_THAN_OR_EQUAL     "GE"
#define ARS_DDE_OPR_BETWEEN                   "BW"
#define ARS_DDE_OPR_NOT_BETWEEN               "NB"
#define ARS_DDE_OPR_IN                        "IN"
#define ARS_DDE_OPR_NOT_IN                    "NI"
#define ARS_DDE_OPR_LIKE                      "LK"
#define ARS_DDE_OPR_NOT_LIKE                  "NL"

#define ARS_DDE_WINDOW_ZOOM                   "Z"
#define ARS_DDE_WINDOW_ICON                   "I"
#define ARS_DDE_WINDOW_NONE                   "N"

/**********************************************************************/
/* DDE Return Data List Item Separator                                */
/**********************************************************************/
#define ARS_DDE_DATA_SEPARATOR                "\t"

/**********************************************************************/
/* DDE Advise Loop Identifiers                                        */
/**********************************************************************/
#define ARS_DDE_ADVISE_LOOP_1                 "1"

/**********************************************************************/
/* DDE Advise Loop Events                                             */
/**********************************************************************/
#define ARS_DDE_EVENT_CRITERIA_BUTTON_1       "0"
#define ARS_DDE_EVENT_CRITERIA_BUTTON_2       "1"
#define ARS_DDE_EVENT_CRITERIA_BUTTON_3       "2"
#define ARS_DDE_EVENT_CRITERIA_BUTTON_4       "3"
#define ARS_DDE_EVENT_CRITERIA_BUTTON_5       "4"
#define ARS_DDE_EVENT_DOCLIST_BUTTON_1        "5"
#define ARS_DDE_EVENT_DOCLIST_BUTTON_2        "6"
#define ARS_DDE_EVENT_DOCLIST_BUTTON_3        "7"
#define ARS_DDE_EVENT_DOCLIST_BUTTON_4        "8"
#define ARS_DDE_EVENT_DOCLIST_BUTTON_5        "9"
#define ARS_DDE_EVENT_SWITCH_FOCUS            "S"
#define ARS_DDE_EVENT_SWITCH_FOCUS_2          "S2"
#define ARS_DDE_EVENT_SWITCH_FOCUS_3          "S3"
#define ARS_DDE_EVENT_SWITCH_FOCUS_4          "S4"
#define ARS_DDE_EVENT_SWITCH_FOCUS_5          "S5"

/**********************************************************************/
/* DDE Command Return Codes                                           */
/**********************************************************************/
#define ARS_DDE_RC_NO_ERROR                      0
#define ARS_DDE_RC_UNKNOWN_COMMAND               1
#define ARS_DDE_RC_PARM_NOT_SPECIFIED            2
#define ARS_DDE_RC_INVALID_PARM_VALUE            3
#define ARS_DDE_RC_SERVER_ERROR                  4
#define ARS_DDE_RC_FILE_ERROR                    5
#define ARS_DDE_RC_NOT_LOGGED_ON                 6
#define ARS_DDE_RC_MAX_FOLDERS_OPEN              7
#define ARS_DDE_RC_FOLDER_NOT_OPEN               8
#define ARS_DDE_RC_NO_DOC                        9
#define ARS_DDE_RC_USER_ACTION_IN_PROGRESS       11
#define ARS_DDE_RC_UNAUTHORIZED_OPERATION        12
#define ARS_DDE_RC_USER_CANCELLED_OPERATION      13
#define ARS_DDE_RC_NO_ACTIVE_DOC                 14
#define ARS_DDE_RC_INVALID_APPL_GROUP_NAME       15
#define ARS_DDE_RC_INVALID_APPL_NAME             16
#define ARS_DDE_RC_INVALID_INTEGER_FIELD         17
#define ARS_DDE_RC_INVALID_DECIMAL_FIELD         18
#define ARS_DDE_RC_INVALID_DATE_FIELD            19
#define ARS_DDE_RC_INVALID_APPLGRP_FIELD_TYPE    20
#define ARS_DDE_RC_DOC_NOT_VIEWABLE_OR_PRINTABLE 21
#define ARS_DDE_RC_INCORRECT_CURRENT_PASSWORD    22
#define ARS_DDE_RC_PASSWORD_TOO_SHORT            23
#define ARS_DDE_RC_NEW_PASSWORD_MISMATCH         24
#define ARS_DDE_RC_INVALID_USER_PASS_SERVER      25
#define ARS_DDE_RC_PASSWORD_EXPIRED              26
#define ARS_DDE_RC_TOO_MANY_VALUE_CHARS          27

/**********************************************************************/
/* DDE Help Context IDs                                               */
/**********************************************************************/
#define ARS_DDE_HELP_ID_CRITERIA_BUTTON_1     0x50800
#define ARS_DDE_HELP_ID_CRITERIA_BUTTON_2     0x50801
#define ARS_DDE_HELP_ID_CRITERIA_BUTTON_3     0x50802
#define ARS_DDE_HELP_ID_CRITERIA_BUTTON_4     0x50803
#define ARS_DDE_HELP_ID_CRITERIA_BUTTON_5     0x50804
#define ARS_DDE_HELP_ID_DOCLIST_BUTTON_1      0x50805
#define ARS_DDE_HELP_ID_DOCLIST_BUTTON_2      0x50806
#define ARS_DDE_HELP_ID_DOCLIST_BUTTON_3      0x50807
#define ARS_DDE_HELP_ID_DOCLIST_BUTTON_4      0x50808
#define ARS_DDE_HELP_ID_DOCLIST_BUTTON_5      0x50809
#define ARS_DDE_HELP_ID_SWITCH_FOCUS          0x5080A
#define ARS_DDE_HELP_ID_SWITCH_FOCUS_2        0x5080B
#define ARS_DDE_HELP_ID_SWITCH_FOCUS_3        0x5080C
#define ARS_DDE_HELP_ID_SWITCH_FOCUS_4        0x5080D
#define ARS_DDE_HELP_ID_SWITCH_FOCUS_5        0x5080E

#endif
